
#include <SPI.h>
#include <WiFi101.h>
#include <PubSubClient.h>

#include "arduino_secrets.h"
///////please enter your sensitive data in the Secret tab/arduino_secrets.h
char ssid[] = SECRET_SSID;        // your network SSID (name)
char pass[] = SECRET_PASS;    // your network password (use for WPA, or use as key for WEP)
int keyIndex = 0;                 // your network key Index number (needed only for WEP)

int status = WL_IDLE_STATUS;
//WiFiServer server(80);

/* Silahkan isi global variable atau constant dibawah ini*/
const int DigIn0 = 0;
const int DigIn1 = 1;
const int DigIn2 = 2;
const int DigIn3 = 3;
 
const int DigOut0 = 4;
const int DigOut1 = 5;
const int DigOut2 = 6;
const int DigOut3 = 7;

int sensorValue0 = 0;  
int sensorValue1 = 0;  
int sensorValue2 = 0;  
int sensorValue3 = 0;  
int sensorValue4 = 0;  
int sensorValue5 = 0;
int sensorValue6 = 0;
    
float Ain0_Voltage;
float Ain1_Voltage;
float Ain2_Voltage;
float Ain3_Voltage;
float Ain4_Voltage;
float Ain5_Voltage;
float Ain6_Voltage;

/* I/O Const and Variable */
float Room_Temperature;
char String_Buff[50];
String Data_Buff; 
/*MQTT Const anda Variable */

const char mqtt_server[] = "192.168.0.11";
const char username[] = "rdd_user";
const char password[] = "rdd_password";

unsigned long currentMillis;
unsigned long previousMillis;

WiFiClient MKRClient;
PubSubClient client(MKRClient);

void setup() {
  Serial.begin(9600);      // initialize serial communication
  // Dibawah ini adalah setup untuk I/O silahkan awali dengan 2x haris miring (//) jika setup tidak dipakai
  analogReadResolution(12);
  pinMode(DigIn0, INPUT);
  pinMode(DigIn1, INPUT);
  pinMode(DigIn2, INPUT);
  pinMode(DigIn3, INPUT);
  pinMode(DigOut0, OUTPUT);
  pinMode(DigOut1, OUTPUT);
  pinMode(DigOut2, OUTPUT);
  pinMode(DigOut3, OUTPUT);

  //Dibawah ini adalah setup program untuk Wifi, untuk mempermudah biarkan seperti apa adanya, 
  // check for the presence of the shield:
  if (WiFi.status() == WL_NO_SHIELD) {
    Serial.println("WiFi shield not present");
    while (true);       // don't continue
  }

  // attempt to connect to WiFi network:
  while ( status != WL_CONNECTED) {
    Serial.print("Attempting to connect to Network named: ");
    Serial.println(ssid);                   // print the network name (SSID);

    // Connect to WPA/WPA2 network. Change this line if using open or WEP network:
    status = WiFi.begin(ssid, pass);
    // wait 10 seconds for connection:
    delay(10000);
  }
  printWiFiStatus();                        // you're connected now, so print out the status
  client.setServer(mqtt_server, 1883);        //masukan Broker IP, Port Broker
}


void loop() {
  // Dibawah ini adalah program template untuk Analog input
  sensorValue0 = analogRead(A0);
  sensorValue1 = analogRead(A1);
  sensorValue2 = analogRead(A2);
  sensorValue3 = analogRead(A3);
  sensorValue4 = analogRead(A4);
  sensorValue5 = analogRead(A5);
  sensorValue6 = analogRead(A6);
  Ain0_Voltage = calcAin_Voltage(sensorValue0);
  Ain1_Voltage = calcAin_Voltage(sensorValue1);
  Ain2_Voltage = calcAin_Voltage(sensorValue2);
  Ain3_Voltage = calcAin_Voltage(sensorValue3);
  Ain4_Voltage = calcAin_Voltage(sensorValue4);
  Ain5_Voltage = calcAin_Voltage(sensorValue5);
  Ain6_Voltage = calcAin_Voltage(sensorValue6);

  // Silahkan buat Program dibawah ini

  client.loop();
  if (!client.connected()) 
  {
    reconnect();
  }
  if (millis() - previousMillis > 1000) 
  {
   Room_Temperature = (125.0/1.25)*Ain0_Voltage;
   Data_Buff = "{ \"a\": ";
   sprintf(String_Buff,"%.2f", Room_Temperature);
   Data_Buff += String_Buff;
   Data_Buff += ", \"b\": 54.6}";
   Data_Buff.toCharArray(String_Buff, Data_Buff.length()+1);
   //Serial.println(Data_Buff);
   previousMillis = millis();
   client.publish("Device19",String_Buff); //Publish data 
   Serial.print("Suhu = ");
   Serial.print(Room_Temperature);
   Serial.println(" DegC");
   //Serial.println(suhu_string);
 }

}

void printWiFiStatus() {
  // print the SSID of the network you're attached to:
  Serial.print("SSID: ");
  Serial.println(WiFi.SSID());

  // print your WiFi shield's IP address:
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);

  // print the received signal strength:
  long rssi = WiFi.RSSI();
  Serial.print("signal strength (RSSI):");
  Serial.print(rssi);
  Serial.println(" dBm");

}

float calcAin_Voltage(int AinValue)
{
  float result;
  result = (5.0/4095.0) * AinValue;
  return result;
}

// MQTT reconnect Function
void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print("Attempting MQTT connection...");
    // Create a random client ID
    String clientId = "MKR1000Client-";
    clientId += String(random(0xffff), HEX);
    // Attempt to connect
    if (client.connect(clientId.c_str(),"rdd_user","rdd_password")) {
      Serial.println("connected");
      // Once connected, publish an announcement...
      // ... and resubscribe
      client.subscribe("RDD/Input1");
    } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}
